#include <iostream>
#include <vector>
#include <algorithm>
#include <limits>
#include <queue>
using namespace std;

typedef vector<vector<pair<int,int> > > Graph;
class Comparator
{
public:
 int operator() ( const pair<int,int>& p1, const pair<int,int> &p2)
 {
 return p1.second>p2.second;
 }
};
/////////////////////////////////////////////////////////////////
void BFSHeap(const Graph  &G,const int &source,const int &destination,vector<int> &path)
{
int X=G.size();
int d[X+1];
int parent[X+1];

for(int i = 0 ; i <= X; i++)//zanulqvam gi
{
 d[i] = 2147483647;
 parent[i] = -1;
}

priority_queue<pair<int,int>, vector<pair<int,int> >, Comparator> Q;
d[source] = 0;//ot kade idvam
Q.push(make_pair(source,d[source]));
while(!Q.empty())
{
 int u = Q.top().first;
 if(u==destination) break;
 Q.pop();
 X=G[u].size();
 for(unsigned int i=0; i < X; i++)
 {
  int v= G[u][i].first;
  int w = G[u][i].second;
  if(d[v] > d[u]+w)
  {
   d[v] = d[u]+w;
   parent[v] = u;
   Q.push(make_pair(v,d[v]));
  }
 }
}
path.clear();
int p = destination;
path.push_back(destination);
while(p!=source)
{
 p = parent[p];
 path.push_back(p);
}
}

int used[1000][1000];

int main()
{
     Graph g;
     int N,M;
     
     FILE *file=fopen("movie.in","r");//otvarq faila za 4etene
     
     fscanf(file,"%d %d",&N,&M);
      g.resize(N+1);
     
    int k;
    
    for(int i=1;i<=M;i++)//za vseki film
    {
            fscanf(file,"%d",&k);//broq aktiori
               int mas[1000];//spisak s aktiorite
       
            for(int j=1;j<=k;j++)  //pro4ita aktiorite za filma
                fscanf(file,"%d",&mas[j]);     
      
            for(int j=1;j<k;j++)//pravene na put
              for(int z=j+1;z<=k;z++)
                    {    
                     
                         if(used[j][z]==0)
                         {
                          g[mas[z]].push_back(make_pair(mas[j],1));//grafa
                          g[mas[j]].push_back(make_pair(mas[z],1));//grafa
                          used[mas[j]][mas[z]]=1;
                          used[mas[z]][mas[j]]=1;
                         }
                    } 
                
                    k=0;
    }
    
  k=0;
 
  //po4va pretursvaneto
   fscanf(file,"%d",&k);
   FILE *f=fopen("movie.out","w");
   for(int i=1;i<=k;i++)//kolkoto puti pravq diikstra
   {
      int beg,end;//purvi i vtori aktior
      vector<int> path;//pravq putq
       fscanf(file,"%d %d",&beg,&end);//pro4itam aktiorite
     
      int fl=0;
      
      if(beg == end){cout<<"out<<"<<0<<endl; fprintf(f,"0\n"); fl=1;}//ako sa eidn i su6t izkarva 0
      else
              {
              BFSHeap(g,beg,end,path); //vikam diikstra
              }
       cout<<i<<endl;system("pause");            
     if(fl==0)
      {
       if(path.size()==0)cout<<"out<<"<<-1<<endl,fprintf(f,"-1\n");//ako ne e namerilo put
       else
     cout<<"out<<"<<path.size()<<endl,  fprintf(f,"%I64d \n",path.size()); //ako e namerilo put izkarva duljinata mu       
      }      
   } 
     
     
     fclose(file);
     fclose(f);
              
    return 0;
}
